<?php
require_once('../config.php'); 

If($_SERVER['REQUEST_METHOD'] === 'GET'){
	$conn = fnGetConnection();
	if(isset($_GET['start_week']) && !empty($_GET['start_week']) && !isset($_GET['type'])){
		getMissedEntry($conn,$_GET['start_week']);
    }
    else if(isset($_GET['from_date']) && isset($_GET['to_date']) && !isset($_GET['type'])){
        getDateRangeReport($conn,$_GET['from_date'],$_GET['to_date']);
    }
    else if(isset($_GET['from_date']) && isset($_GET['to_date']) && isset($_GET['type'])){
        excelExport($conn,$_GET['from_date'],$_GET['to_date']);
        exit;
    }
    else if(isset($_GET['start_week']) && isset($_GET['type'])){
        excelExportMissingEntry($conn,$_GET['start_week']);
        exit;
    }
	mysqli_close($conn);
}

function getMissedEntryData($conn,$start_week){
    $sql = "SELECT 
				EMP.name,
				sum(entry_hours) as total_hours
			FROM timesheet.timeentry TE
			LEFT JOIN timesheet.employees EMP on EMP.id = TE.employee_id
			where TE.week_start = '".$start_week."' AND EMP.status='active'
			GROUP BY TE.employee_id
			HAVING COUNT(TE.employee_id) >= 1 and sum(entry_hours) < 40 
			UNION ALL
			SELECT 
				EMP.name,
				0 as total_hours
			FROM timesheet.employees EMP
			WHERE id NOT IN(select employee_id from timesheet.timeentry where week_start='".$start_week."' group by employee_id) AND EMP.status='active'";
	return $conn->query($sql);
}

function getMissedEntry($conn,$start_week){
	$queryResult = getMissedEntryData($conn,$start_week);
	$json_array  = array();
	if($queryResult->num_rows > 0){
		while($row = $queryResult->fetch_assoc()){
			$json_array[] = $row;
		}
	}
	echo json_encode($json_array);exit;
}

function getDateRangeReport($conn,$from_date,$to_date){
    $queryResult = getReportData($conn,$from_date,$to_date);
    $data        = [];
    $json_array  = array();
    $date_from   = strtotime($from_date);
    $date_to     = strtotime($to_date); 
	if($queryResult->num_rows > 0){
		while($row = $queryResult->fetch_assoc()){
            $saved_items  = explode(',',$row['saved_entries']);
            $entry_detais = [];
            foreach($saved_items as $value){
                $entry = explode('|',$value);
                $entry_detais[date('d-M-Y',strtotime($entry[0]))] =  $entry[1] ;
            }
            $rowTotal = 0;
            for ($i=$date_from; $i<=$date_to; $i+=86400) { 
                $dateValue = date("d-M-Y", $i); 
                if(isset($entry_detais[$dateValue])){
                    $row[$dateValue] = $entry_detais[$dateValue]; 
                    $rowTotal += $entry_detais[$dateValue]; 
                }
                else{
                    $row[$dateValue] = '';
                }
            }
            unset($row['saved_entries']);
            $row['total_hours'] = $rowTotal;
            $json_array[] = $row;
		}
    }
    echo json_encode($json_array);exit;
}

function getReportData($conn,$from_date,$to_date)
{
    $sql = "Select 
        b.name empName, 
        f.name client, 
        e.project_name, 
        d.subtask_name, 
        c.name activity_name, 
        d.billable,
        group_concat(ConCat(ConCat(x.entry_date, '|'), x.entry_hours) Order By x.entry_date) saved_entries 
        From 
            timesheet.employee_subtask_mapping a 
        Left Outer Join timesheet.timeentry x on a.subtask_id = x.subtask_id and a.activity_id = x.activity_id and a.employee_id = x.employee_id, 				timesheet.employees b, timesheet.activities c, timesheet.subtask d, timesheet.projects e, timesheet.clients f  
        Where a.employee_id = b.id And a.activity_id = c.id And a.subtask_id = d.id And d.project_id = e.id And e.client_id = f.id And e.status IN ('active','inactive') And x.entry_date between '$from_date' and '$to_date' 
        Group By a.subtask_id, a.activity_id, a.employee_id 
        Order By empName, client, project_name";
    return $conn->query($sql);
}

function getReportArray($result)
{

}

function excelExport($conn,$from_date,$to_date)
{
    ini_set('max_execution_time', 0);
    ini_set("memory_limit", "2G");
    $filename = "timesheet_" . $from_date . "_to_".$to_date.".xls";
    header ('Content-Type: application/octet-stream');
    header('Content-Disposition: attachment; filename='.$filename);

    $queryResult   = getReportData($conn,$from_date,$to_date);
    $data          = [];
    $json_array    = array();
    $date_from     = strtotime($from_date);
    $date_to       = strtotime($to_date); 
    $isPrintHeader = false;
	if($queryResult->num_rows > 0){
		while($row = $queryResult->fetch_assoc()){
            $saved_items  = explode(',',$row['saved_entries']);
            $entry_detais = [];
            foreach($saved_items as $value){
                $entry = explode('|',$value);
                $entry_detais[date('d-M-Y',strtotime($entry[0]))] =  $entry[1] ;
            }
            $rowTotal = 0;
            for ($i=$date_from; $i<=$date_to; $i+=86400) { 
                $dateValue = date("d-M-Y", $i); 
                if(isset($entry_detais[$dateValue])){
                    $row[$dateValue] = $entry_detais[$dateValue];  
                    $rowTotal += $entry_detais[$dateValue];
                }
                else{
                    $row[$dateValue] = '';
                }
            }
            unset($row['saved_entries']);
            $row['total_hours'] = $rowTotal;
            if (! $isPrintHeader) {
                echo strtoupper(implode("\t", array_keys($row))) . "\n";
                $isPrintHeader = true;
            }
            echo implode("\t", array_values($row)) . "\n";
		}
    }
    exit();
}

function excelExportMissingEntry($conn,$start_week)
{
    ini_set('max_execution_time', 0);
    ini_set("memory_limit", "2G");
    $filename = "Missing_Entry_" . $start_week . ".xls";
    header ('Content-Type: application/octet-stream');
    header('Content-Disposition: attachment; filename='.$filename);

    $queryResult   = getMissedEntryData($conn,$start_week);
    $isPrintHeader = false;
	if($queryResult->num_rows > 0){
		while($row = $queryResult->fetch_assoc()){
            if (! $isPrintHeader) {
                echo strtoupper(implode("\t", array_keys($row))) . "\n";
                $isPrintHeader = true;
            }
            echo implode("\t", array_values($row)) . "\n";
		}
    }
    exit();
}

?>

<html>
	<head>
		<link href="https://fonts.googleapis.com/css?family=Roboto&display=swap" rel="stylesheet">
		<link rel="stylesheet" href="../timesheet_v4.css">
		<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
		<title>Dvara Timesheet - Admin</title>
	</head>
	<body onload="fnPageLoadReport()">
    <div id='client_div' class="flex-container" style="width:99%; text-align: center;">
        <table>
            <tr>
                <td style="border: none !important;font-size: 15px;font-weight: bold;">
                    Reports
                </td>
                <td style="float:right;border: none !important;">
                    <a href="timesheet_admin.php"><input type="button" value="Home"></a>	
                </td>
            </tr>
        </table>
	</div>
    <div id='client_div' style="width:99%; text-align: left;">
        <div style="width:50%;">
            <label for='ts__reportselection'>Select Report: </label>
            <select id='ts__reportselection' onchange='fnSelectReport(this.value)'>
                <option value=""> -- Select Report -- </option>
                <option value="weekly"> Missing Report </option>
                <option value="date_range"> Date Range </option>
            </select>
        </div>
        <br />
        <div id="week_selection_div" style="width:40%; display:none;">
            <label for='ts__weekselection'>Select Week: </label>
            <select id='ts__weekselection' onchange='fnDisplayMissedEntry(this.value)'>
            </select>
            <span>
            <input type="button" id="excel_export" style="float:right;"  onclick="fnGetMissingReportExcel()" value="Download">
            </span>
        </div>
        <div id="range_selection_div" style="text-align: center;width:90%; display:none;">
            <span >
                <label style="font-weight:bold;">From date: </label>
                <input id='from_date' type="date">
            </span>
            <span>
                <label style="font-weight:bold;">To date: </label>
                <input id='to_date' type="date">
            </span>

            <br/> <br/>
            <span>
            
            <input type="button" id="submit_date" onclick="fnGetDateRangeReport()" value="Show"></span>
            <span>
            <input type="button" id="excel_export"  onclick="fnGetDateRangeExcel()" value="Download">
            </span>
        </div>       
        <br />
        <div id='missed_entry_report_div' style="display: none; text-align: center;width:40%;">
        </div>
        <div id='date_range_report_div' style="overflow-x:auto;height: 60%;display: none; text-align: center;width:100%;">
        </div>			
    </div> 
	<br>
	</body>
</html>
<script type="text/javascript" src="../timesheet_v4.js"></script>