var selection = {client: '', project: '', subtask: '',client_row : '',activity_row:'',employee_row:''};
//var dateFormatOptions = {year: 'numeric', month: 'short', day: 'numeric' };
var dateFormatOptions = {day: '2-digit', month: 'short', year: 'numeric' };

function fnPageLoadAdmin(){
	fnBuildClientList();
}

function fnPageLoadMasters(){
	fnLoadClient();
	fnLoadActivities();
    fnLoadEmployees();

}

function fnPageLoadReport(){
	fnBuildWeekList();
	var missed_entry_report_div = document.getElementById('missed_entry_report_div');

	missed_entry_report_div.style.display ='none';
	// fnDisplayMissedEntry(document.getElementById('ts__weekselection').value);
}

function fnBuildClientList(){
	var selectBox = document.getElementById('ts__clientlist');
	let option = document.createElement("option");
	option.textContent = 'Select Client';
	option.value = '';	
	selectBox.appendChild(option);
	var resMsg_json = JSON.parse(localStorage.getItem('ts_admin_localstorage'));
	for(let i=0;i<resMsg_json.clients.length;i++){
		let option = document.createElement("option");
		option.value = resMsg_json.clients[i].client_id;
		option.textContent = resMsg_json.clients[i].client_name;
		selectBox.appendChild(option);
	}

}

function fnChangeClient(obj){
	selection.client = obj.value;
	selection.project = '';
	let project_div = document.getElementById('project_div');
	project_div.innerHTML = '';
	project_div.style.display = 'block';

	let subtask_div = document.getElementById('subtask_div');
	subtask_div.innerHTML = '';

	let resMsg_json = JSON.parse(localStorage.getItem('ts_admin_localstorage'));
	let tbl = document.createElement('table');
	tbl.style.textTransform = "capitalize";
	let bdy;
	let firstRow = 0;
	for(let i=0;i<resMsg_json.projects.length;i++){
		if(resMsg_json.projects[i].client_id === obj.value){
			if(firstRow===0){
				fnBuildTRHead(resMsg_json.projects[i], tbl);
				bdy = tbl.createTBody();
			}
			//var tr = bdy.insertRow();
			fnBuildTRBody(resMsg_json.projects[i], tbl, bdy, 'project');
			firstRow += 1;
		}
	}
	project_div.appendChild(tbl);
}

function fnLoadClient(){
	let client_div = document.getElementById('client_list_div');
	if(!client_div){
		return;
	}
	client_div.innerHTML = '';
	client_div.style.display = 'block';

	let resMsg_json = JSON.parse(localStorage.getItem('ts_admin_localstorage'));
	let tbl = document.createElement('table');
	tbl.style.textTransform = "capitalize";
	let bdy;
	let firstRow = 0;
	for(let i=0;i<resMsg_json.clients.length;i++){
			if(firstRow===0){
				fnBuildTRHead(resMsg_json.clients[i], tbl);
				bdy = tbl.createTBody();
			}
			//var tr = bdy.insertRow();
			fnBuildTRBody(resMsg_json.clients[i], tbl, bdy, 'client');
			firstRow += 1;
		
	}
	client_div.appendChild(tbl);
}

function fnLoadActivities(){
	let activity_div = document.getElementById('activity_list_div');
	if(!activity_div){
		return;
	}
	activity_div.innerHTML = '';
	activity_div.style.display = 'block';

	let resMsg_json = JSON.parse(localStorage.getItem('ts_admin_localstorage'));
	let tbl = document.createElement('table');
	tbl.style.textTransform = "capitalize";
	let bdy;
	let firstRow = 0;
	for(let i=0;i<resMsg_json.activities.length;i++){
			if(firstRow===0){
				fnBuildTRHead(resMsg_json.activities[i], tbl);
				bdy = tbl.createTBody();
			}
			//var tr = bdy.insertRow();
			fnBuildTRBody(resMsg_json.activities[i], tbl, bdy, 'activity');
			firstRow += 1;
		
	}
	activity_div.appendChild(tbl);
}

function fnLoadEmployees(){
	let employee_div = document.getElementById('employee_list_div');
	if(!employee_div){
		return;
	}
	employee_div.innerHTML = '';
	employee_div.style.display = 'block';

	let resMsg_json = JSON.parse(localStorage.getItem('ts_admin_localstorage'));
	let tbl = document.createElement('table');
	tbl.style.textTransform = "capitalize";
	let bdy;
	let firstRow = 0;
	for(let i=0;i<resMsg_json.employees.length;i++){
			if(firstRow===0){
				fnBuildTRHead(resMsg_json.employees[i], tbl);
				bdy = tbl.createTBody();
			}
			//var tr = bdy.insertRow();
			fnBuildTRBody(resMsg_json.employees[i], tbl, bdy, 'employee');
			firstRow += 1;
		
	}
	employee_div.appendChild(tbl);
}

function fnBuildTRHead(tableRowData, tbl){
	var hdr = tbl.createTHead();
	var tr = hdr.insertRow();
	var td;
	for (var key in tableRowData) {
		td = tr.insertCell();
		td.innerHTML = fnCapFirstLetter(key);
	}
}

function fnBuildTRBody(tableRowData, tbl, bdy, type){
	let tr = bdy.insertRow();
	tr.id = tableRowData.client_id + '~' + tableRowData.project_id;
	if(type==='project'){
		tr.addEventListener('click', (function(){ fnDisplaySubTask(tableRowData.project_id, this); }));
	}
	if(type==='subtask'){
		tr.addEventListener('click', (function(){ fnDisplayEmployees(tableRowData.subtask_id, this); }));
	}
	if(type==='client'){
		tr.addEventListener('click', (function(){ fnDisplayClient(tableRowData.client_id, this);; }));
	}
	if(type==='activity'){
		tr.addEventListener('click', (function(){ fnDisplayActivity(tableRowData.activity_id, this); }));
	}
	if(type==='employee'){
		tr.addEventListener('click', (function(){ fnDisplayEmployee(tableRowData.employee_id, this); }));
	}
	let td;
	for (var key in tableRowData) {
		let keyValue;
		if(key.match(/date/g) !== null){
			keyValue = new Date(tableRowData[key]);
			keyValue = keyValue.toLocaleDateString("en-IN", dateFormatOptions);
		}else{
			keyValue = tableRowData[key];
		}
		td = tr.insertCell();
		td.innerHTML = keyValue;
	}
}

function fnDisplayClient(clientId,obj)
{
	selection.client_row = clientId;
	let eachRow = obj.parentNode.getElementsByTagName('tr');
	let rowList = Array.prototype.slice.call(eachRow);
	rowList.forEach(function(rows){
		rows.style.backgroundColor = '';
	});
	obj.style.backgroundColor=(obj.style.backgroundColor=='#e9edf0')?('transparent'):('#e9edf0');
}

function fnDisplayActivity(activityId,obj)
{
	selection.activity_row = activityId;
	let eachRow = obj.parentNode.getElementsByTagName('tr');
	let rowList = Array.prototype.slice.call(eachRow);
	rowList.forEach(function(rows){
		rows.style.backgroundColor = '';
	});
	obj.style.backgroundColor=(obj.style.backgroundColor=='#e9edf0')?('transparent'):('#e9edf0');
}

function fnDisplayEmployee(employeeId,obj)
{
	selection.employee_row = employeeId;
	let eachRow = obj.parentNode.getElementsByTagName('tr');
	let rowList = Array.prototype.slice.call(eachRow);
	rowList.forEach(function(rows){
		rows.style.backgroundColor = '';
	});
	obj.style.backgroundColor=(obj.style.backgroundColor=='#e9edf0')?('transparent'):('#e9edf0');
}

function fnDisplaySubTask(projectID, obj){
	selection.project = projectID;
	selection.subtask = '';
	let subtask_div = document.getElementById('subtask_div');
	subtask_div.innerHTML = '';
	subtask_div.style.display = 'block';

	let eachRow = obj.parentNode.getElementsByTagName('tr');
	let rowList = Array.prototype.slice.call(eachRow);
	rowList.forEach(function(rows){
		rows.style.backgroundColor = '';
	});
	//obj.style.backgroundColor=(obj.style.backgroundColor=='rgb(253, 222, 187)')?('transparent'):('rgb(253, 222, 187)');
	obj.style.backgroundColor=(obj.style.backgroundColor=='#e9edf0')?('transparent'):('#e9edf0');
	//obj.style.backgroundColor=(obj.style.backgroundColor=='#e9edf0';

	let resMsg_json = JSON.parse(localStorage.getItem('ts_admin_localstorage'));
	for(let i=0;i<resMsg_json.subtasks.length;i++){
		if(resMsg_json.subtasks[i].project_id === projectID){
			let eachSubTaskDiv = document.createElement('div');
			eachSubTaskDiv.className = 'eachSubTaskDiv';
			/*
			let editDiv = document.createElement('div');
			editDiv.style.textAlign = "right";
			editDiv.innerHTML = '';
			editDiv.onclick = function(e){fnEditSubTask(resMsg_json.subtasks[i].subtask_id);};
			*/


			let editIcon = document.createElement('i');
			editIcon.className="fa fa-edit";
			editIcon.style.float = "right";
			editIcon.style.cursor = "pointer";
			editIcon.onclick = function(e){fnEditSubTask(resMsg_json.subtasks[i].subtask_id);};


			eachSubTaskDiv.appendChild(editIcon);
			
			let p = document.createElement('p');
			p.style.fontWeight = 'bold';
			p.innerHTML = resMsg_json.subtasks[i].subtask_name;
			eachSubTaskDiv.appendChild(p);

			p = document.createElement('p');
			let fDate = new Date(resMsg_json.subtasks[i].from_date);
			let tDate = new Date(resMsg_json.subtasks[i].to_date);
			p.innerHTML = fDate.toLocaleDateString("en-IN", dateFormatOptions)+ '    <=>    ' + tDate.toLocaleDateString("en-IN", dateFormatOptions);
			eachSubTaskDiv.appendChild(p);

			p = document.createElement('p');
			p.innerHTML = resMsg_json.subtasks[i].utilized_effort+ ' / ' + resMsg_json.subtasks[i].total_effort + ' Utilization';
			if(parseInt(resMsg_json.subtasks[i].utilized_effort)>parseInt(resMsg_json.subtasks[i].total_effort)){
				p.style.color = 'red';
			}else{
				p.style.color = '';
			}
			eachSubTaskDiv.appendChild(p);

			p = document.createElement('p');
			if(resMsg_json.subtasks[i].billable === 'N')
				p.innerHTML = 'Non-Billable Project';
			else
				p.innerHTML = 'Billable Project';
			eachSubTaskDiv.appendChild(p);

			if(resMsg_json.subtasks[i].billable === 'Y'){
				p = document.createElement('p');
				p.innerHTML = '';
				if(resMsg_json.subtasks[i].client_approved === 'N'){
					p.innerHTML = 'Pending Approval';
					p.style.color = 'red';
				}else{
					p.innerHTML = 'Approval Received';
				}
				if(resMsg_json.subtasks[i].payment_received === 'N'){
					p.innerHTML += ' & Pending Payment';
					p.style.color = 'red';
				}else{
					p.innerHTML += ' & Payment Received';
				}
				eachSubTaskDiv.appendChild(p);
			}

			let hr = document.createElement('hr');
			eachSubTaskDiv.appendChild(hr);

			//Show mapped employees
			let empDiv = document.createElement('div');
			empDiv.className = 'allMappedEmpDiv';
			fnDisplayMappedEmp(resMsg_json.subtasks[i].subtask_id, empDiv, eachSubTaskDiv);

			subtask_div.appendChild(eachSubTaskDiv);
		}
	}
}

function fnDisplayMappedEmp(subTaskID, childDiv, parentDiv){
	let resMsg_json = JSON.parse(localStorage.getItem('ts_admin_localstorage'));
	let employees_for_subtask = new Array();
	let employee_count = 0;
	for(let i=0;i<resMsg_json.employees_mapped.length;i++){
		if(resMsg_json.employees_mapped[i].subtask_id === subTaskID){
			
			if(employee_count > 9){
				let empDiv = document.createElement('div');
				empDiv.className = 'eachMappedEmp';
				empDiv.innerHTML = "...";
				childDiv.appendChild(empDiv);
				parentDiv.appendChild(childDiv);
				return;
			}
			var is_employee_exist = employees_for_subtask.indexOf(resMsg_json.employees_mapped[i].employee_id);
  			if(is_employee_exist > -1){
			
			}else{
				employee_count++;
				employees_for_subtask.push(resMsg_json.employees_mapped[i].employee_id);
				let empDiv = document.createElement('div');
				empDiv.className = 'eachMappedEmp';
				empDiv.innerHTML = resMsg_json.employees_mapped[i].name;
				childDiv.appendChild(empDiv);
				parentDiv.appendChild(childDiv);
			}
		}
	}
}

function fnEditSubTask(subTaskID){
	selection.subtask = subTaskID;
	let subTaskPopup = document.getElementById('new_subtask_div');
	subTaskPopup.style.display = 'block';
	let resMsg_json = JSON.parse(localStorage.getItem('ts_admin_localstorage'));
	document.getElementById('emp_list_div').innerHTML = '';
	for(let i=0;i<resMsg_json.subtasks.length;i++){
		if(resMsg_json.subtasks[i].subtask_id === subTaskID){
			document.getElementById('subtask__subtaskname').value = resMsg_json.subtasks[i].subtask_name;
			document.getElementById('subtask__fromdate').value = resMsg_json.subtasks[i].from_date;
			document.getElementById('subtask__todate').value = resMsg_json.subtasks[i].to_date;
			document.getElementById('subtask__billable').value = resMsg_json.subtasks[i].billable;
			document.getElementById('subtask__totaleffort').value = resMsg_json.subtasks[i].total_effort;
			document.getElementById('subtask__clientapproved').value = resMsg_json.subtasks[i].client_approved;
			document.getElementById('subtask__paymentreceived').value = resMsg_json.subtasks[i].payment_received;
			fillEmpDataList();
			fnFillActivityDiv(subTaskID);
		}
	}
}

function fnFillActivityDiv(subTaskID){
	let subtask_activity_div = document.getElementById('subtask_activities_div');
	subtask_activity_div.innerHTML = '';
	let resMsg_json = JSON.parse(localStorage.getItem('ts_admin_localstorage'));
	for(let i=0;i<resMsg_json.activities.length;i++){
		// let p = document.createElement('p');
		// p.textContent = 'Activity - ' + resMsg_json.activities[i].name;
		// subtask_activity_div.appendChild(p);

		let emp_search_div = document.createElement('div');
		emp_search_div.style.marginTop="15px";
		// emp_search_div.appendChild(p);
		emp_search_div.innerHTML ='<span style="width:50%;">Activity - '+resMsg_json.activities[i].name+'</span><span id="search_employee" style="float: right; width: 40%;margin-top: -10px;"><input type="list" list="employees_dl" onchange="fnOnEmployeeSelection(this,'+resMsg_json.activities[i].activity_id+')" placeholder="Search Employee" /><datalist id="employees_dl"></datalist></span>';
		subtask_activity_div.appendChild(emp_search_div);
		let div = document.createElement('div');
		div.id='activity__'+resMsg_json.activities[i].activity_id;
		div.className = 'emp_list_div';
		//div.ondragover="allowDrop(event)";
		if(subTaskID !== '' && subTaskID !== null){
			fnFillActivityEmpDiv(subTaskID, resMsg_json.activities[i].activity_id, resMsg_json, div);
		}
		
		subtask_activity_div.appendChild(div);
	}
}

function fnFillActivityEmpDiv(subTaskID, activityID, resMsg, divObj){
	if(resMsg.employees_mapped.length>0){
		for(let i=0;i<resMsg.employees_mapped.length;i++){
			if(resMsg.employees_mapped[i].subtask_id === subTaskID && resMsg.employees_mapped[i].activity_id === activityID){
				let empDiv = document.createElement('div');
				empDiv.className        = 'eachMappedEmp';
				empDiv.id               = resMsg.employees_mapped[i].employee_id;
				empDiv.draggable        = 'true';
				empDiv.innerHTML        = resMsg.employees_mapped[i].name;

				let removeIcon          = document.createElement('i');
				removeIcon.className    = "fa fa-remove";
				removeIcon.style.float  = "right";
				removeIcon.style.paddingLeft  = "5px";
				removeIcon.style.cursor = "pointer";
				removeIcon.style.color  = "darkred";

				removeIcon.onclick      = function(e){this.parentNode.remove();};
				empDiv.appendChild(removeIcon);
				divObj.appendChild(empDiv);
			}
		}
	}
}

function fillEmpDataList(){
	let empDL = document.getElementById('employees_dl');
	empDL.innerHTML = '';
	let resMsg_json = JSON.parse(localStorage.getItem('ts_admin_localstorage'));
	for(let i=0;i<resMsg_json.employees.length;i++){
		let el = document.createElement("option");
		el.value = resMsg_json.employees[i].employee_id;
		el.textContent = resMsg_json.employees[i].name;
		empDL.appendChild(el);
	}
}

function fnOnEmployeeSelection(obj,activity_id){
	
	// let empListDiv = document.getElementById('emp_list_div');
	let empListDiv = document.getElementById('activity__'+activity_id);
	let resMsg_json = JSON.parse(localStorage.getItem('ts_admin_localstorage'));
	for(let i=0;i<resMsg_json.employees.length;i++){
		if(resMsg_json.employees[i].employee_id === obj.value){
			let empDiv = document.createElement('div');
			empDiv.className = 'eachMappedEmp';
			empDiv.id = resMsg_json.employees[i].employee_id;
			empDiv.draggable = 'true';
			empDiv.innerHTML = resMsg_json.employees[i].name;

			let removeIcon          = document.createElement('i');
			removeIcon.className    = "fa fa-remove";
			removeIcon.style.float  = "right";
			removeIcon.style.paddingLeft  = "5px";
			removeIcon.style.cursor = "pointer";
			removeIcon.style.color  = "darkred";

			removeIcon.onclick      = function(e){this.parentNode.remove();};
			empDiv.appendChild(removeIcon);
			empListDiv.appendChild(empDiv);
			obj.value = '';
		}
	}
}

document.ondragstart = function(event) {
	event.dataTransfer.setData("Text", event.target.id);
};

/* Events fired on the drop target */
document.ondragover = function(event) {
	event.preventDefault();
};

document.ondrop = function(event) {
	event.preventDefault();
	var data = event.dataTransfer.getData("Text")
	event.target.appendChild(document.getElementById(data));
};

function fnCapFirstLetter(heading) {
	let name = heading.split('_');
	let returnName = '';
	if(name.length>0){
		for(let i=0;i<name.length;i++){
			returnName += name[i].charAt(0).toUpperCase() + name[i].slice(1) + ' ';
		}
	}
    return returnName;
}

function fnShowPopup(div, type){
	if(type === 'new_project'){
		//selection.project = '';
		if(selection.client !== '' && selection.client !== null){
			fnFillProjectDetails();
		}else{
			alert('Please select client first.');
			return;
		}
	}else if(type === 'new_subtask'){
		selection.subtask = '';
		if(selection.project !== '' && selection.project !== null){
			var fieldList = 'subtask__subtaskname~subtask__fromdate~subtask__todate~subtask__totaleffort~employees_dl';
			fieldList = fieldList.split('~');
			for(let i=0;i<fieldList.length;i++){
				document.getElementById(fieldList[i]).value='';
			}
			document.getElementById('subtask_activities_div').innerHTML = '';
			document.getElementById('emp_list_div').innerHTML = '';
			fillEmpDataList();
			fnFillActivityDiv('');
		}else{
			alert('Please select project.');
			return;
		}
	}else if(type === 'employee'){
		if(selection.subtask !== '' && selection.subtask !== null){
		}else{
			alert('Please select subtask.');
			return;
		}
	}else if(type === 'new_client'){
		if(selection.client_row !== '' && selection.client_row !== null && selection.client_row !== undefined){
			fnFillClientDetails();
		}else{
			
		}
	}else if(type === 'new_activity'){
		if(selection.activity_row !== '' && selection.activity_row !== null && selection.activity_row !== undefined){
			fnFillActivityDetails();
		}else{
			
		}
	}else if(type === 'new_employee'){
		if(selection.employee_row !== '' && selection.employee_row !== null && selection.employee_row !== undefined){
			fnFillEmployeeDetails();
		}else{
			
		}
	}
	
	var modal = document.getElementById(div);
	if(modal != undefined){
		modal.style.display = "block";
	}
	
}

function fnCloseModal(div){
	var modal = document.getElementById(div);
	modal.style.display = "none";
}

function fnFillProjectDetails(){
	if(selection.project !== '' && selection.project !== null){
		var resMsg_json = JSON.parse(localStorage.getItem('ts_admin_localstorage'));
		for(let i=0;i<resMsg_json.projects.length;i++){
			if(selection.project === resMsg_json.projects[i].project_id){
				document.getElementById('project__projectname').value = resMsg_json.projects[i].project_name;
				document.getElementById('project__fromdate').value = resMsg_json.projects[i].from_date;
				document.getElementById('project__todate').value = resMsg_json.projects[i].to_date;
				document.getElementById('project__active').value = resMsg_json.projects[i].status;
			}
		}
	}else{
		document.getElementById('project__projectname').value = '';
		document.getElementById('project__fromdate').value = '';
		document.getElementById('project__todate').value = '';
		document.getElementById('project__active').value = 'active';
	}
}

function fnFillClientDetails(){
	if(selection.client_row !== '' && selection.client_row !== null && selection.client_row != undefined){
		var resMsg_json = JSON.parse(localStorage.getItem('ts_admin_localstorage'));
		for(let i=0;i<resMsg_json.clients.length;i++){
			if(resMsg_json.clients[i].client_id && selection.client_row === resMsg_json.clients[i].client_id){
				document.getElementById('client_clientname').value = resMsg_json.clients[i].client_name;
			}
		}
	}else{
		document.getElementById('client_clientname').value = '';
	}
}

function fnFillActivityDetails(){
	if(selection.activity_row !== '' && selection.activity_row !== null && selection.activity_row != undefined){
		var resMsg_json = JSON.parse(localStorage.getItem('ts_admin_localstorage'));
		for(let i=0;i<resMsg_json.activities.length;i++){
			if(resMsg_json.activities[i].activity_id && selection.activity_row === resMsg_json.activities[i].activity_id){
				document.getElementById('activity_activityname').value = resMsg_json.activities[i].name;
			}
		}
	}else{
		document.getElementById('activity_activityname').value = '';
	}
}

function fnFillEmployeeDetails(){
	if(selection.employee_row !== '' && selection.employee_row !== null && selection.employee_row != undefined){
		var resMsg_json = JSON.parse(localStorage.getItem('ts_admin_localstorage'));
		for(let i=0;i<resMsg_json.employees.length;i++){
			if(resMsg_json.employees[i].employee_id && selection.employee_row === resMsg_json.employees[i].employee_id){
				document.getElementById('employee_employeename').value = resMsg_json.employees[i].name;
				document.getElementById('employee__employeetype').value = resMsg_json.employees[i].login_type;
				document.getElementById('employee__employeestatus').value = resMsg_json.employees[i].status;
			}
		}
	}else{
		document.getElementById('activity_activityname').value = '';
	}
}

function fnSaveProject(){
	if(selection.client !== '' && selection.client !== null){
		if(document.getElementById('project__projectname').value === '' || document.getElementById('project__projectname').value === null){
			alert('Project name is mandatory');
			return;
		}
		var projectDetails = new Object();
		projectDetails.client_id = selection.client;
		if(selection.project === '' || selection.project === null){
			projectDetails.service = 'new_project';
		}else{
			projectDetails.service = 'edit_project';
			projectDetails.project_id = selection.project;
		}
		//projectDetails.operation = 'new';
		projectDetails.project_name = document.getElementById('project__projectname').value;
		projectDetails.from_date = document.getElementById('project__fromdate').value;
		projectDetails.to_date = document.getElementById('project__todate').value;
		projectDetails.status = document.getElementById('project__active').value;
		postAjax('admin', JSON.stringify(projectDetails));
		selection.project = '';
	}else{
		alert('Please select client first.');
		return;
	}
}

function fnSaveClient(){
	
		if(document.getElementById('client_clientname').value === '' || document.getElementById('client_clientname').value === null){
			alert('Client name is mandatory');
			return;
		}
		var clientDetails = new Object();
		if(selection.client_row === '' || selection.client_row === null || selection.client_row === undefined){
			clientDetails.service = 'new_client';
		}else{
			clientDetails.service = 'edit_client';
			clientDetails.client_id = selection.client_row;
		}
		//projectDetails.operation = 'new';
		clientDetails.client_name = document.getElementById('client_clientname').value;
		postAjax('admin', JSON.stringify(clientDetails));
		selection.client_row = '';
	
}

function fnSaveActivity(){
	
		if(document.getElementById('activity_activityname').value === '' || document.getElementById('activity_activityname').value === null){
			alert('Activity name is mandatory');
			return;
		}
		var activityDetails = new Object();
		if(selection.activity_row === '' || selection.activity_row === null || selection.activity_row === undefined){
			activityDetails.service = 'new_activity';
		}else{
			activityDetails.service = 'edit_activity';
			activityDetails.activity_id = selection.activity_row;
		}
		//projectDetails.operation = 'new';
		activityDetails.activity_name = document.getElementById('activity_activityname').value;
		postAjax('admin', JSON.stringify(activityDetails));
		selection.activity_row = '';
	
}

function fnSaveEmployee(){
	
		if(document.getElementById('employee_employeename').value === '' || document.getElementById('employee_employeename').value === null){
			alert('Emloyee name is mandatory');
			return;
		}
		var employeeDetails = new Object();
		if(selection.employee_row === '' || selection.employee_row === null || selection.employee_row === undefined){
			employeeDetails.service = 'new_employee';
		}else{
			employeeDetails.service = 'edit_employee';
			employeeDetails.employee_id = selection.employee_row;
		}
		//projectDetails.operation = 'new';
		employeeDetails.employee_name = document.getElementById('employee_employeename').value;
		employeeDetails.login_type = document.getElementById('employee__employeetype').value;
		employeeDetails.status = document.getElementById('employee__employeestatus').value;
		postAjax('admin', JSON.stringify(employeeDetails));
		selection.employee_row = '';
	
}

function fnSaveSubtask(){
	if(selection.client !== '' && selection.client !== null && selection.project !== '' && selection.project !== null){
		if(document.getElementById('subtask__subtaskname').value === '' || document.getElementById('subtask__subtaskname').value === null){
			alert('Subtask name is mandatory');
			return;
		}
		var subTaskDetails = new Object();
		subTaskDetails.subtask_id = selection.subtask;
		subTaskDetails.project_id = selection.project;
		if(selection.subtask === ''){
			subTaskDetails.service = 'new_subtask';
		}else{
			subTaskDetails.service = 'edit_subtask';
		}
		//subTaskDetails.operation = 'new';
		subTaskDetails.subtask_name = document.getElementById('subtask__subtaskname').value;
		subTaskDetails.from_date = document.getElementById('subtask__fromdate').value;
		subTaskDetails.to_date = document.getElementById('subtask__todate').value;
		subTaskDetails.billable = document.getElementById('subtask__billable').value;
		if(document.getElementById('subtask__totaleffort').value === '' || document.getElementById('subtask__totaleffort').value === null){
			subTaskDetails.total_effort = 0;
		}else{
			subTaskDetails.total_effort = document.getElementById('subtask__totaleffort').value;
		}
		subTaskDetails.client_approved = document.getElementById('subtask__clientapproved').value;
		subTaskDetails.payment_received = document.getElementById('subtask__paymentreceived').value;
		let empList = fnGetMappedEmps();
		subTaskDetails['activities'] = empList;
		postAjax('admin', JSON.stringify(subTaskDetails));
	}else{
		alert('Please select project first.');
		return;
	}
}

function fnGetMappedEmps(){
	var resMsg_json = JSON.parse(localStorage.getItem('ts_admin_localstorage'));
	let empList1 = [];
	if(resMsg_json.activities.length>0){
		for(let i=0;i<resMsg_json.activities.length;i++){
			let activityDiv = document.getElementById("activity__"+resMsg_json.activities[i].activity_id);
			if(activityDiv.children){
				if(activityDiv.children.length){
					let empList = [];
					for(let j=0;j<activityDiv.children.length;j++){
						empList.push({"emp_id":activityDiv.children[j].id});
					}
					empList1.push({'activity_id':resMsg_json.activities[i].activity_id,  'employees': empList});
				}
			}
		}
	}
	return empList1;
}

function postAjax(module, data) {
	let url='';
	if(module==='admin'){
		url = 'timesheet_admin.php';
		// url = '/timesheet/admin/timesheet_admin.php';
	}else if(module==='timeentry'){
		//url = '/timeentry/timeentry.php';
		// url = '/timesheet/timeentry/timeentry.php';
		url=window.location.href;
	}
	
	var xhr = new XMLHttpRequest();
	xhr.open("POST", url, true);
	xhr.setRequestHeader("Content-Type", "application/json; charset=utf-8");
	xhr.onreadystatechange = function () {
		if (xhr.readyState === 4 && xhr.status === 200) {
			fnPaintResMsg(JSON.parse(xhr.responseText), module);
		}
	};
	xhr.send(data);
}

function fnPaintResMsg(resMsg, module){
	if(module === 'admin'){
		localStorage.setItem("ts_admin_localstorage", JSON.stringify(resMsg));
		fnClosePopup();
		let prodID = selection.project;
		let clientSelectBox = document.getElementById('ts__clientlist');
		if(clientSelectBox)
			fnChangeClient(clientSelectBox);
		fnLoadClient();
		fnLoadActivities();
    	fnLoadEmployees();
		var tbl = document.getElementById('project_div');
		let selectedRow = '';
		if(tbl && tbl.children[0].tBodies[0].childNodes){
			if(tbl.children[0].tBodies[0].childNodes.length>0){
				for(let i=0;i<tbl.children[0].tBodies[0].childNodes.length;i++){
					let client_project = tbl.children[0].tBodies[0].childNodes[i].id.split('~');
					if(client_project[1] === prodID){
						selectedRow = tbl.children[0].tBodies[0].childNodes[i];
					}
				}
			}
		}
		if(selectedRow !== ''){
			fnDisplaySubTask(prodID, selectedRow);
		}
		if(prodID !== '' || prodID !== null){
			selection.project = prodID;
		}
		alert('Saved.');
	}else if(module === 'timeentry'){
		localStorage.setItem("ts_entry_localstorage", JSON.stringify(resMsg));
		alert('Timesheet saved.');
	}
}

function fnClosePopup(){
	if(document.getElementById('new_project_div'))
		document.getElementById('new_project_div').style.display = 'none';
	if(document.getElementById('new_subtask_div'))	
		document.getElementById('new_subtask_div').style.display = 'none';
	if(document.getElementById('new_client_modal'))
		document.getElementById('new_client_modal').style.display = 'none';
	if(document.getElementById('new_activity_modal'))
		document.getElementById('new_activity_modal').style.display = 'none';
	if(document.getElementById('new_employee_modal'))
		document.getElementById('new_employee_modal').style.display = 'none';
}

document.onkeydown = function(evt) {
    evt = evt || window.event;
    if (evt.keyCode == 27) {
    	let popupDiv;
		popupDiv = document.getElementById('new_project_div');
		if(popupDiv.style.display === 'block'){
			fnCloseModal('new_project_div');
		}
		popupDiv = document.getElementById('new_subtask_div');
		if(popupDiv.style.display === 'block'){
			fnCloseModal('new_subtask_div');
		}
    }
};

//====================================================================================================================

function fnPageLoadEntry(){
	//fnBuildEmpList();
	fnBuildWeekList();
	fnTotalTimeEntered();
}
/*
function fnBuildEmpList(){
	var selectBox = document.getElementById('ts__emplist');
	let option = document.createElement("option");
	option.textContent = 'Select Employee';
	option.value = '';
	selectBox.appendChild(option);
	var resMsg_json = JSON.parse(localStorage.getItem('ts_entry_localstorage'));
	for(let i=0;i<resMsg_json.employees.length;i++){
		let option = document.createElement("option");
		option.value = resMsg_json.employees[i].employee_id;
		option.textContent = resMsg_json.employees[i].name;
		selectBox.appendChild(option);
	}
}
*/
function fnChangeEmpForTimeEntry(obj){
	let projDiv = document.getElementById('project_div');
	projDiv.style.display = 'block';
	projTableHdr = projDiv.children[0].children[0];
	projTableHdr.innerHTML = '';
	projTableBdy = projDiv.children[0].children[1];
	projTableBdy.innerHTML = '';
	let weekStart = document.getElementById('ts__weekselection');
	weekStart.value = '';
}

function fnBuildWeekList(){
	var selectBox = document.getElementById('ts__weekselection');
	let option = document.createElement("option");
	option.textContent = 'Start of the Week';
	option.value = '';
	selectBox.appendChild(option);
	let dt = new Date();
	while (dt.getDay() != 1) {
	  dt.setDate(dt.getDate() - 1);
	}
	for(let i=15;i>=-1;i--){
		let previousMonday = new Date(dt);
		previousMonday.setDate(previousMonday.getDate() - (i*7));
		let previousMonday1 = [
				  previousMonday.getFullYear(),
				  ('0' + (previousMonday.getMonth() + 1)).slice(-2),
				  ('0' + previousMonday.getDate()).slice(-2)
				].join('-');

		option = document.createElement("option");
		if(i===0){
			option.setAttribute('selected', true);
		}
		option.value = previousMonday1;
		option.textContent = new Date(previousMonday1).toLocaleDateString("en-IN", dateFormatOptions);
		selectBox.appendChild(option);
	}
	fnDisplayMappedProjectOnSelectedDate(selectBox);
}

function fnDisplayMappedProjectOnSelectedDate(obj){
	let projDiv = document.getElementById('project_div');
	//projDiv.innerHTML = '';
	if(!projDiv)
	{
		return;
	}
	projTableHdr = projDiv.children[0].children[0];
	projTableHdr.innerHTML = '';
	projTableBdy = projDiv.children[0].children[1];
	projTableBdy.innerHTML = '';
	let empId = document.getElementById('ts__emplist').value;
	if(empId === '' || empId === null){
		obj.value = '';
		alert('Select Employee name first.');
		return;
	}
	if(obj.value === ''){
		return;
	}

	let clientProjectName = '';

	var resMsg_json = JSON.parse(localStorage.getItem('ts_entry_localstorage'));
	let firstRow = 0;
	let sevenDays = 0;

	var monthShortNames = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
	var dayShortNames = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];
	
	let previousSeven = new Date(obj.value);
	previousSeven.setDate(previousSeven.getDate() - 7);
	if(resMsg_json.emp_mapped_projects.length>0){
		var clientName = null;
		var projectCount = 0;
		for(let i=0;i<resMsg_json.emp_mapped_projects.length;i++){
			if(resMsg_json.emp_mapped_projects[i].employee_id === empId){
				projDiv.style.display = 'block';
				let previousSeven = new Date(resMsg_json.emp_mapped_projects[i].from_date);
				previousSeven.setDate(previousSeven.getDate() - 6);
				if(previousSeven <= new Date(obj.value) && new Date(resMsg_json.emp_mapped_projects[i].to_date) >= new Date(obj.value)){

					let tr;
					let td;

					if(firstRow === 0){
						tr = document.createElement('tr');
						for(let day=0;day<8;day++){
							td = document.createElement('td');
							if(day === 0){
								td.innerHTML = 'Project - Sub-Task - Activity';
							}else{
								let runningDate = new Date(obj.value);
								runningDate.setDate(runningDate.getDate() + sevenDays);
								td.innerHTML = dayShortNames[runningDate.getDay()] +' '+ runningDate.getDate() + ' ' + monthShortNames[runningDate.getMonth()];
								sevenDays += 1;
							}
							tr.appendChild(td);
						}
						projTableHdr.appendChild(tr);

						let total_tr  = document.createElement('tr');
						for(let day=-1;day<7;day++){
							if(day==-1){
								let empty_td = document.createElement('td');
								total_tr.appendChild(empty_td);
								continue;
							}
							let total_tds = document.createElement('td');
							let total_input = document.createElement('input');
							total_input.type = 'text';
							total_input.id = 'total_'+day;
							total_input.className = 'notReadtOnly1';
							total_input.readOnly=true;
							total_input.size = 4;
							total_tds.appendChild(total_input);
							total_tr.appendChild(total_tds);
						}
						projTableHdr.appendChild(total_tr);
					}
					
					if(clientName != resMsg_json.emp_mapped_projects[i].client){
						projectCount ++ ;
						clientName = resMsg_json.emp_mapped_projects[i].client;
						trClient = document.createElement('tr');
						trClient.className = "clientHeader";
						
						tdClient = document.createElement('td');
						tdClient.colSpan = 8;
						tdClient.innerHTML = projectCount +") "+ resMsg_json.emp_mapped_projects[i].client;
						tdClient.style.fontWeight = "bold";
						trClient.appendChild(tdClient);
						projTableBdy.appendChild(trClient);
					}
					tr = document.createElement('tr');
					tr.className = "clientProjects";
					tr.style.display = "none";
					tr1 = document.createElement('tr');
					
					tr.id = resMsg_json.emp_mapped_projects[i].subtask_id+'~'+resMsg_json.emp_mapped_projects[i].activity_id;
					tr.addEventListener('click', (function(){ fnSetTableRowColor(this); }));
					td = document.createElement('td');
					
					td.innerHTML =  resMsg_json.emp_mapped_projects[i].project_name + ' - ' + resMsg_json.emp_mapped_projects[i].subtask_name + ' - ' + resMsg_json.emp_mapped_projects[i].activity_name;;
					tr.appendChild(td);

					for(let day=0;day<7;day++){
						let runningDate = new Date(obj.value);
						runningDate.setDate(runningDate.getDate() + day);
						let runningDate1 = [
								  runningDate.getFullYear(),
								  ('0' + (runningDate.getMonth() + 1)).slice(-2),
								  ('0' + runningDate.getDate()).slice(-2)
								].join('-');
						let savedEntry = resMsg_json.emp_mapped_projects[i].saved_entries;
						let savedDate = '';
						let savedHour = '';
						if(savedEntry !== '' && savedEntry !== null){
							savedEntry = savedEntry.split(',');
							
							if(savedEntry){
								for(k=0;k<savedEntry.length;k++){
									savedEntry1 = savedEntry[k].split('|');
									if(savedEntry1){
										savedDate = savedEntry1[0];
										savedHour = savedEntry1[1];
										if(runningDate1 === savedDate){
											break;
										}else{
											savedDate = '';
											savedHour = '';
										}
									}
								}
							}
						}
						td = document.createElement('td');
						let input = document.createElement('input');
						input.type = 'text';
						input.id = 'ts_entry_time_txt';
						input.value = savedHour;
						input.size = 4;
						input.maxLength = 2;
						input.onblur = function (e) {fnTimeEntryOut(this)};
						if(new Date(runningDate) < new Date(resMsg_json.emp_mapped_projects[i].from_date) || new Date(runningDate) > new Date(resMsg_json.emp_mapped_projects[i].to_date) || day>=5){
							//input.setAttribute("readonly", true);
							input.readOnly = true;
							input.className = "readtOnly1";
						}else{
							//input.setAttribute("readonly", false);
							input.readOnly = false;
							input.className = 'notReadtOnly1';
						}
						
						if(runningDate1 == "2019-07-21" || runningDate1 == '2019-09-01' || runningDate1 == '2019-09-07' || runningDate1 == '2019-09-08' || runningDate1 == '2019-09-14' || runningDate1 == '2019-09-15' || runningDate1 == '2019-09-21' || runningDate1 == '2019-09-22' || runningDate1 == '2019-09-28' || runningDate1 == '2019-09-29' || runningDate1 == '2019-11-16'){
							input.readOnly = false;
							input.className = 'notReadtOnly1';
						}
						input.className +=" txt_col_"+day;
						input.addEventListener('change', function(e) {
							var sum=0;
							var x = document.getElementsByClassName('txt_col_'+day);
							for(var i = 0; i<x.length; i++){
								if(x[i].value !='' && x[i].value!=null){
									sum += parseInt(x[i].value);
								}
							}
							if(sum > 8){
								alert("Total should be 8 Hours per day!");
								this.value='';
							}
							else{
								document.getElementById('total_'+day).value = sum;
							}
						  }, false);
						td.appendChild(input);
						tr.appendChild(td);
					}
					tr1.appendChild(tr);
					projTableBdy.appendChild(tr);
					firstRow += 1;
				}
			}
		}
	}
	for(let day=0;day<7;day++){
		var total_hours = 0;
		var x = document.getElementsByClassName('txt_col_'+day);
		for(var i = 0; i<x.length; i++){
			if(x[i].value !='' && x[i].value!=null){
				total_hours += parseInt(x[i].value);
			}
		}
		if(total_hours > 0){
			document.getElementById('total_'+day).value = total_hours;
		}				
	}
	fnTotalTimeEntered();
}

function fnSetTableRowColor(row){
	/*
	let eachRow = row.parentNode.getElementsByTagName('tr');
	let rowList = Array.prototype.slice.call(eachRow);
	rowList.forEach(function(rows){
		rows.style.backgroundColor = '';
	});
	row.style.backgroundColor=(row.style.backgroundColor=='#e9edf0')?('transparent'):('#e9edf0');
	*/
}

function fnSaveTimeEntry(){
	let empID = document.getElementById('ts__emplist').value;
	let weekStartDay = document.getElementById('ts__weekselection').value;
	let tblBdy = document.getElementById('project_div').children[0].children[1];
	let timeEntryList = [];
	if(tblBdy.children.length>0){
		for(let i=0;i<tblBdy.children.length;i++){
			let eachTR = tblBdy.children[i];
			let ids = eachTR.id;
			let idArray = ids.split('~');
			let subtaskID = idArray[0];
			let activityID = idArray[1];
			let weekStartDate;
			let weekStartDay1 = new Date(weekStartDay);
			weekStartDay1.setDate(weekStartDay1.getDate() - 1);
			let eachTD = eachTR.children;
			for(let j=0;j<7;j++){
				weekStartDay1.setDate(weekStartDay1.getDate() + 1);
				let entryDay = [
						  weekStartDay1.getFullYear(),
						  ('0' + (weekStartDay1.getMonth() + 1)).slice(-2),
						  ('0' + weekStartDay1.getDate()).slice(-2)
						].join('-');
				if(j===0){
					weekStartDate = entryDay;
				}
				
				if(eachTD[j+1] && eachTD[j+1].children[0].value.trim() !== '' && eachTD[j+1].children[0].value.trim() !== null){
					if(!isNaN(eachTD[j+1].children[0].value.trim())){
						if(eachTD[j+1].children[0].value.trim()>=0){
							timeEntryList.push({"employee_id":empID, "subtask_id":subtaskID, "activity_id":activityID, "entry_date": entryDay, "entry_hours": eachTD[j+1].children[0].value, "week_start": weekStartDate});
						}
					}
				}
			}
		}
		if(timeEntryList === null || timeEntryList === '' || timeEntryList.length < 1){
			alert('Nothing to save');
			return;
		}else{
			postAjax('timeentry', JSON.stringify(timeEntryList));
		}
	}else{
		alert('Enter time entries');
		return;
	}
}

function fnTimeEntryOut(obj){
	if(obj.value !== '' && obj.value !== null){
		if(isNaN(obj.value)){
			alert('Only numeric please');
			obj.value = '';
			obj.focus();
		}else{
			if(obj.value < 0 || obj.value > 8){
				alert('Please Enter 0 to 8');
				obj.value = '';
				obj.focus();
			}
		}
	}
	fnTotalTimeEntered();
}

function fnLoginPageLoad(){
	document.getElementById('ts__username').focus();
}

function fnTotalTimeEntered(){
	let projDiv = document.getElementById('project_div');
	projTableBdy = projDiv.children[0].children[1];
	let totalCount = 0;
	let inputTextCount = projTableBdy.getElementsByTagName("input").length;
	if(inputTextCount > 0){
		for(let i=0;i<inputTextCount;i++){
			let eachInputText = projTableBdy.getElementsByTagName("input")[i].value;
			if(parseInt(eachInputText))
				totalCount += parseInt(eachInputText);
		}
	}
	document.getElementById("timeentry_total").value = totalCount + ' Hours';
}


function fnFilterProjects(){
	var input, filter, table, tr, td, i;
	var val = document.getElementById("filter_text").value;
	
	input = document.getElementById("filter_text");
	filter = input.value.toUpperCase();
	table = document.getElementById("mapped_project_tbl").lastElementChild;
	tr = table.getElementsByTagName("tr");
	for (i = 0; i < tr.length; i++) {
		td = tr[i].getElementsByTagName("td")[0];
		if (td) {
			txtValue = td.textContent || td.innerText;
			if (txtValue.toUpperCase().indexOf(filter) > -1) {
				tr[i].style.display = "";
			} else {
				tr[i].style.display = "none";
			}
		}
	}
}

function fnDisplayMissedEntry(value){
	var url=window.location.href;
	let report_div = document.getElementById('missed_entry_report_div');
	if(value){
		var xhttp = new XMLHttpRequest();
		xhttp.onreadystatechange = function() {
			if (this.readyState == 4 && this.status == 200) {
				var resultJson           = JSON.parse(this.responseText);
				report_div.innerHTML     = '';
				report_div.style.display = 'block';
				let tbl                  = document.createElement('table');
				let bdy;
				let firstRow             = 0;
				let length               = resultJson.length;
				for(let i=0;i<length;i++){
					if(firstRow===0){
						fnBuildTRHead(resultJson[i], tbl);
						bdy = tbl.createTBody();
						firstRow += 1;
					}
					fnBuildTRBody(resultJson[i], tbl, bdy, 'project');					
				}
				report_div.appendChild(tbl);
			}
		};
		xhttp.open("GET", url+"/getMissedEntry?start_week="+value, true);
		xhttp.send();
	}
	else	{
		report_div.appendChild("");
	}
}

function fnSelectReport(value)
{
	var week_selection_div                = document.getElementById('week_selection_div');
	var range_selection_div               = document.getElementById('range_selection_div');
	var missed_entry_report_div           = document.getElementById('missed_entry_report_div');	
	var date_range_report_div             = document.getElementById('date_range_report_div');	
	week_selection_div.style.display      = 'none';
	missed_entry_report_div.style.display = 'none';
	date_range_report_div.style.display   = 'none';
	range_selection_div.style.display     = 'none';		
	if(value == "weekly"){
		week_selection_div.style.display = 'block';
		fnDisplayMissedEntry(document.getElementById('ts__weekselection').value);
	}
	else if(value=="date_range"){
		range_selection_div.style.display = 'block';
	}
}

function fnGetDateRangeReport()
{
	var url        = window.location.href;
	var from_date  = document.getElementById('from_date').value;
	var to_date    = document.getElementById('to_date').value;
	let report_div = document.getElementById('date_range_report_div');
	if(from_date && to_date){
		var xhttp = new XMLHttpRequest();
		xhttp.onreadystatechange = function() {
			if (this.readyState == 4 && this.status == 200) {
				var resultJson = JSON.parse(this.responseText);
				report_div.innerHTML = '';
				report_div.style.display = 'block';				
				let tbl = document.createElement('table');
				let bdy;
				let firstRow = 0;
				let range_length = resultJson.length;
				for(let i=0;i<range_length;i++){
						if(firstRow === 0){
							fnBuildTRHead(resultJson[i], tbl);
							bdy = tbl.createTBody();
							firstRow += 1;
						}
					fnBuildTRBody(resultJson[i], tbl, bdy, 'project');					
				}
				report_div.appendChild(tbl);
			}
		};
		xhttp.open("GET", url+"/getDateRangeReport?from_date="+from_date+"&to_date="+to_date, true);
		xhttp.send();
	}
	else{
		alert("Please select From Date and To Date!");
	}
}

function fnGetDateRangeExcel()
{
	var url        = window.location.href;
	var from_date  = document.getElementById('from_date').value;
	var to_date    = document.getElementById('to_date').value;
	let report_div = document.getElementById('date_range_report_div');
	let hrefUrl = url+"?from_date="+from_date+"&to_date="+to_date+"&type=xl_export";
	if(from_date && to_date){
		var a = document.createElement('a');
		a.title = "Excel Export";
		a.href = hrefUrl.trim();
		document.body.appendChild(a);
		a.click();
		a.remove();
	}
	else{
		alert("Please select From Date and To Date!");
	}
}

function fnGetMissingReportExcel()
{
	var url        = window.location.href;
	var start_week  = document.getElementById('ts__weekselection').value;
	let hrefUrl = url+"?start_week="+start_week+"&type=xl_export";
	if(start_week){
		var a = document.createElement('a');
		a.title = "Excel Export";
		a.href = hrefUrl.trim();
		document.body.appendChild(a);
		a.click();
		a.remove();
	}
	else{
		alert("Please select Week!");
	}
}

